#pragma once
#include <map>
#include <vector>

// CNodeMap

class CNodeMap : public CStatic
{
        DECLARE_DYNAMIC(CNodeMap)

public:
        CNodeMap();
        virtual ~CNodeMap();
        void SetInfo(std::vector<SYSTEM_LOGICAL_PROCESSOR_INFORMATION> & LPI);

protected:
        class CoreInfo {
            public:
               CoreInfo() { ProcessorMask = 0; Flags = 0; }
               CoreInfo(ULONG_PTR mask, UCHAR f) { ProcessorMask = mask; Flags = f; }
            public:
               ULONG_PTR ProcessorMask;
               UCHAR Flags;
        };

        class PackageInfo {
            public:
               PackageInfo() { ProcessorMask = 0; }
               PackageInfo(ULONG_PTR mask) { ProcessorMask = mask;} 
            public:
               ULONG_PTR ProcessorMask;
               std::vector<CoreInfo> Cores;
               CRect rect;
        };
        
        class NodeInfo {
            public:
               NodeInfo() { Node = 0; ProcessorMask = 0; }
               NodeInfo(DWORD nd, ULONG_PTR mask) {  Node = nd; ProcessorMask = mask; }
            public:
               DWORD Node;
               ULONG_PTR ProcessorMask;
               CRect rect;
        };
protected:

        std::vector<NodeInfo> Nodes;
        std::vector<PackageInfo> Packages;
        HFONT Font;
protected:
        CString BitMaskToNumbers(UINT_PTR mask);
        void DrawCores(CDC & dc, const CRect & r, const std::vector<CoreInfo> & Cores);

protected:
        DECLARE_MESSAGE_MAP()
        afx_msg void OnPaint();
        afx_msg void OnSize(UINT nType, int cx, int cy);
        afx_msg BOOL OnEraseBkgnd(CDC * pDC);
        afx_msg LRESULT OnSetFont(WPARAM, LPARAM);
        afx_msg LRESULT OnGetFont(WPARAM, LPARAM);
};


