// XMLDisplay.cpp : implementation file
//

#include "stdafx.h"
#include "XMLDisplay.h"
#include "..\XMLBuilder\XMLBuilder.h"

// CXMLDisplay

IMPLEMENT_DYNAMIC(CXMLDisplay, CComboBox)

const UINT CXMLDisplay::UWM_QUERY_NODE = ::RegisterWindowMessage(_T("UWM_QUERY_NODE") _T("{55BD2781-9604-4b44-8E50-9677E4BCB153}"));

CXMLDisplay::CXMLDisplay()
{

}

CXMLDisplay::~CXMLDisplay()
{
}


BEGIN_MESSAGE_MAP(CXMLDisplay, CComboBox)
    ON_CONTROL_REFLECT(CBN_DROPDOWN, &CXMLDisplay::OnCbnDropdown)
    ON_CONTROL_REFLECT(CBN_CLOSEUP, &CXMLDisplay::OnCbnCloseup)
END_MESSAGE_MAP()



// CXMLDisplay message handlers




/****************************************************************************
*                        CXMLDisplay::PreSubclassWindow
* Result: void
*       
* Effect: 
*       Sets the first element to be "XML"
****************************************************************************/

void CXMLDisplay::PreSubclassWindow()
   {
    AddString(_T("XML"));
    SetCurSel(0);
    
    CComboBox::PreSubclassWindow();
   }


/****************************************************************************
*                          CXMLDisplay::OnCbnDropdown
* Result: void
*       
* Effect: 
*       Requests the node and expands it
****************************************************************************/

void CXMLDisplay::OnCbnDropdown()
   {
    ResetContent();
    AddString(_T("XML"));

    XMLNode * node = (XMLNode*)GetParent()->SendMessage(UWM_QUERY_NODE, MAKEWPARAM(GetDlgCtrlID(), XMLN_DROPDOWN), (LPARAM)m_hWnd);
    if(node == NULL)
        return;

     CClientDC dc(this);
     CFont * f = GetFont();
     dc.SelectObject(f);
     
     int width = 0;

     CString text = XMLToString(node);

     while(!text.IsEmpty())
        { /* convert it */
         int n = text.Find(_T("\n"));
         if(n < 0)
            { /* done */
             AddString(text);
             break;
            } /* done */
         CString s = text.Left(n);
         AddString(s);
         int w = dc.GetTextExtent(s).cx;
         if(w > width)
            width = w;
         text = text.Mid(n + 1);
        } /* convert it */
     width += ::GetSystemMetrics(SM_CXVSCROLL);
     SetDroppedWidth(width);
   }

/****************************************************************************
*                          CXMLDisplay::OnCbnCloseup
* Result: void
*       
* Effect: 
*       Resets the selection to 0
****************************************************************************/

void CXMLDisplay::OnCbnCloseup()
   {
    SetCurSel(0);
   }
