#pragma once

class NUMATags {
    public:
       class Tag {
           public:
              static const CString NUMA;
       };
       class DataTags {
           public:
              //****************************************************************
              // <NUMA:GetNumaHighestNodeNumber Value="1"
              //****************************************************************
              static const CString Data;
              class GetNumaHighestNodeNumberTags {
                  public:
                     static const CString GetNumaHighestNodeNumber;
                     class Attributes {
                         public:
                            static const CString Value;
                     }; // NUMATags::DataTags::GetNumaHighestNodeNumberTags::Attributes
              }; // NUMATags::DataTags::GetNumaHighestNodeNumberTags

              //****************************************************************
              // <NUMA:SYSTEM_INFO dwNumberOfProcessors="4"/>
              //****************************************************************
              class SYSTEM_INFOTags {
                  public:
                     static const CString SYSTEM_INFO;
                     class Attributes {
                         public:
                            static const CString wProcessorArchitecture;
                            static const CString dwPageSize;
                            static const CString lpMinimumApplicationAddress;
                            static const CString lpMaximumApplicationAddress;
                            static const CString dwActiveProcessorMask;
                            static const CString dwNumberOfProcessors;
                            static const CString dwProcessorType;
                            static const CString dwAllocationGranularity;
                            static const CString wProcessorLevel;
                            static const CString wProcessorRevision;
                     }; // NUMATags::DataTags::SYSTEM_INFOTags::Attributes
              }; // NUMATags::DataTags::SYSTEM_INFOTags

              //****************************************************************
              // <NUMA:GetNumaProcessorNode>
              //    <NUMA:ProcessorNode Processor="0" Node="0"/>
              //****************************************************************
              class GetNumaProcessorNodeTags {
                  public:
                     static const CString GetNumaProcessorNode;
                     //****************************************************************
                     // GetNumaProcessorNode:ProcessorNode
                     //****************************************************************
                     class ProcessorNodeTags {
                         public:
                            static const CString ProcessorNode;
                            class Attributes {
                                public:
                                   static const CString Processor;
                                   static const CString Node;
                            }; // NUMATags::DataTags::GetNumaProcessorNodeTags::ProcessorNode::Attributes
                     }; // NUMATags::DataTags::GetNumaProcessorNodeTags::ProcessorNode
              }; // NUMATage::DataTags::GetNumaProcessorNodeTags

              //****************************************************************
              // <NUMA:GetNumaProcessorMask>
              //    <Numa:ProcessorMask Node="0" ProcessorMask="0x00000003"/>
              //    <Numa:ProcessorMask Node="1" ProcessorMask="0x0000000C"/>
              // </NUMA:GetNumaProcessorMask>
              //****************************************************************
              class GetNumaProcessorMaskTags {
                  public:
                     static const CString GetNumaProcessorMask;
                     class ProcessorMaskTags {
                         public:
                            static const CString ProcessorMask;
                            class Attributes {
                                public:
                                   static const CString ProcessorMask;
                                   static const CString Node;
                            }; // NUMATags::DataTags::GetNumaProcessorMaskTags::ProcessorMask
                     }; // NUMATags::DataTags::GetNumaProcessorMaskTags::ProcessorMask
              }; // NUMATags::DataTags::GetNumaProcessorMaskTags

              //****************************************************************
              // <NUMA:GetNumaAvailableMemory>
              //    <NUMA:NumaAvailableMemory Node="0" KBytes="0"/>
              //    <NUMA:NumaAvailableMemory Node="1" KBytes="0"/>
              // </NUMA:GetNumaAvailableMemory>
              //****************************************************************
              class GetNumaAvailableMemoryNodeTags {
                  public:
                     static const CString GetNumaAvailableMemoryNode;
                     class NumaAvailableMemoryTags {
                         public:
                            static const CString NumaAvailableMemory;
                            class Attributes {
                                public:
                                   static const CString Node;
                                   static const CString KBytes;
                            }; //NUMATags::DataTags::GetNumaAvailableMemoryTags::NumaAvaileAbleMemoryTags::Attributes
                     }; // NUMATags::DataTags::GetNumaAvailableMemoryTags::NumaAvaileAbleMemoryTags
              }; // NUMATags::DataTags::GetNumaAvailableMemoryTags

              //****************************************************************
              // <NUMA:GetLogicalProcessorInformation>
              //    <NUMA:RelationProcessorCore ProcessorMask="0x000001" Flags="0x00/>
              //    <NUMA:RelationCache ProcessorMask="0x0000001" Level="1" Associativity="1" LineSize="64" Type="2" TypeName="CacheData" />
              //    <NUMA:RelationProcessorPackage ProcessorMask="0x00000003"/>
              //    <NUMA:RelationNumaNode ProcessorMask="0x00000003" NodeNumber="0"/>
              // </NUMA:GetLogicalProcessorInformation>
              //****************************************************************
              class GetLogicalProcessorInformationTags {
                  public:
                     static const CString GetLogicalProcessorInformation;
                     //****************************************************************
                     // GetLogicalProcessorInformation:RelationProcessoreCore
                     //****************************************************************
                     class RelationProcessorCoreTags {
                         public:
                            static const CString RelationProcessorCore;
                            class Attributes {
                                public:
                                   static const CString ProcessorMask;
                                   static const CString Flags;
                            }; // NUMATags::DataTags::GetLogicalProcessorInformationTags::RelationProcessorCoreTags::Attributes
                     }; // NUMATags::DataTags::GetLogicalProcessorInformationTags::RelationProcessorCoreTags

                     //****************************************************************
                     // GetLogicalProcessorInformation:RelationCache
                     //****************************************************************
                     class RelationCacheTags {
                         public:
                            static const CString RelationCache;
                            class Attributes {
                                public:
                                   static const CString ProcessorMask;
                                   static const CString Level;
                                   static const CString Associativity;
                                   static const CString LineSize;
                                   static const CString Type;
                                   static const CString TypeName;
                            }; // NUMATags::DataTags::GetLogicalProcessorInformationTags::RelationCacheTags::Attributes
                     }; // NUMATags::DataTags::GetLogicalProcessorInformationTags::RelationCacheTags

                     //****************************************************************
                     // GetLogicalProcessorInformation:RelationProcessorePackage
                     //****************************************************************
                     class RelationProcessorPackageTags {
                         public:
                            static const CString RelationProcessorPackage;
                            class Attributes {
                                public:
                                   static const CString ProcessorMask;
                            }; // NUMATags::DataTags::GetLogicalProcessorInformationTags::RelationProcessorPackageTags::Attributes
                     }; // NUMATags::DataTags::GetLogicalProcessorInformationTags::RelationProcessorPackageTags

                     //****************************************************************
                     // GetLogicalProcessorInformation:RelationNumaNode
                     //****************************************************************
                     class RelationNumaNodeTags {
                         public:
                            static const CString RelationNumaNode;
                            class Attributes {
                                public:
                                   static const CString ProcessorMask;
                                   static const CString Node;
                            }; // NUMATags::DataTags::GetLogicalProcessorInformationTags::RelationNumaNodeTags::Attributes
                     }; // NUMATags::DataTags::GetLogicalProcessorInformationTags::RelationProcessorPackageTags
              }; // NUMATags::DataTags::GetLogicalProcessorInformationTags

              //****************************************************************
              // <NUMA:VirtualAllocExNuma>
              //   <NUMA:Allocation Low="0x12345678" High="0x23456789" Node="0"/>
              // </NUMA:VirtualAllocExNuma>
              //****************************************************************
              class VirtualAllocExNumaTags {
                  public:
                     static const CString VirtualAllocExNuma;
                     class AllocationTags {
                         public:
                            static const CString Allocation;
                            class Attributes {
                                public:
                                   static const CString CPU;
                                   static const CString Low;
                                   static const CString High;
                                   static const CString Node;
                                   static const CString Valid;
                            }; // NUMATags::DataTags::VirtualAllocExNumaTags::AllocationTags::Attributes
                     }; // NUMATags::DataTags::VirtualAllocExNumaTags::AllocationTags
              }; // NUMATags::DataTags::VirtualAllocExNumaTags
              //****************************************************************
              // <NUMA:QueryWorkingSetEx>
              //    <NUMA:PSAPI_WORKING_SET_EX_INFORMATION
              //                Valid = "false"/>
              //    <NUMA:PSAPI_WORKING_SET_EX_INFORMATION
              //                Valid = "true"
              //                ShareCount="1"
              //                Win32Proection="0x0000"
              //                Shared="true"
              //                Node="0"
              //                Locked="false"
              //                LargePage="false" />
              // </NUMA:QueryWorkingSetEx>
              //****************************************************************
              class QueryWorkingSetExTags {
                  public:
                     static const CString QueryWorkingSetEx;
                     class PSAPI_WORKING_SET_EX_INFORMATIONTags {
                         public:
                            static const CString PSAPI_WORKING_SET_EX_INFORMATION;
                            class Attributes {
                                public:
                                   static const CString VirtualAddress;
                                   static const CString Flags;
                                   static const CString Valid;
                                   static const CString ShareCount;
                                   static const CString Win32Protection;
                                   static const CString Shared;
                                   static const CString Node;
                                   static const CString Locked;
                                   static const CString LargePage;
                            }; // NUMATags::DataTags::QueryWOrkingSetExTags::PSAPI_WORKING_SET_EX_INFORMATION::Attributes
                     }; // NUMATags::DataTags::QueryWOrkingSetExTags::PSAPI_WORKING_SET_EX_INFORMATION
              }; // NUMATags::DataTags::QueryWOrkingSetExTags
       }; // NUMATags::DataTags
}; // NUMATags
